# 2021-03-18 Meeting

## Attendees

- Derek Ardolf
- Sage Robins
- Gareth Greenaway
- Jim Cser
- Gary Giesen

## Meeting Details

### Announcements

- Docs Clinic next week: March 25th
  - We can't add this to the Twitch calendar, since the Twitch calendar only allows
    for daily and/or weekly scheduled streams, not bi-weekly/bi-monthly/etc.

### Future of the working groups and docs clinics

Will we continue doing Docs clinics and the working group?
- Yes! We are going to try running it for another month or two to see whether
  it is a continued, viable workgroup to run. With Alyssa leaving us, Derek is
  now the main captain of the ship, along with fellow Docs heroes. The Docs
  Clinics will continue to run on alternate weeks, streaming on Twitch:
  - [SaltProjectOSS Twitch](https://www.twitch.tv/saltprojectoss)

### Notes of Interest

#### Borked docs pipeline fixed

Issue in Salt raised this week: [Documentation broken in `master`](https://github.com/saltstack/salt/issues/59798)

#### Dependency tree complexity

A follow-up to the broken docs pipeline is this PR:
- [Update Sphinx and docs.in / docs.txt dependency trees](https://github.com/saltstack/salt/pull/59823)

We really should evaluate something like `poetry`, in addition to tooling like
`safety`, as integrations into our pipelines.
- I need to work with Tyler to ensure lessons learned are being implemented in the bootstrapping of new `idem` projects.
- If able, would be a good idea to see about getting `poetry` into the bootstrapping of new `salt-ext` / salt extensions?
  - Pedro has created some simple tooling on generating new `salt-ext` projects, and we need to take a look at how dependency trees are managed, whether `poetry` is a viable solution, and how test automation would work.
  - How do we avoid dependency tree conflicts with `salt` and a `salt-ext`?

#### `salt-ext` documentation bootstrapping

Template/bootstrapping for both `salt-ext` and `pop-create*` should make use of the `furo` theme as a drop-in replacement of the `saltstack-material-theme`.

How do we reference extensions in documentation, and provide an easier/better discovery experience for users?
- How do we bring the docs together for `salt-ext` projects?
- How do we provide a gallery/supermarket of docs discovery for available internally supported (and community supported?) extensions?
  - What does the onboarding process end up looking like for community-maintained projects?

We should provide:
- `README.rst` template
- `CONTRIBUTING.rst` template
  - `CODE_OF_CONDUCT.md` referencing `salt/CODE_OF_CONDUCT.md`
  - `SECURITY.md` template (pointint to `salt/SECURITY.md`)

#### EPIC: Undocumented minion/master configurations

[Next Docs Jam idea: PR salt/58112](https://gitlab.com/saltstack/open/docs/docs-hub/-/blob/main/meeting-notes/2021-03-04.md#next-docs-jam-idea-pr-salt58112)
  - https://github.com/saltstack/salt/issues/58112
  - Recent Twitch stream on this (audio/video is totally unsynced, should be fixed by next stream): https://www.twitch.tv/videos/945679337

#### Furo: A/B UX of docs delayed

Derek originally had the goal of getting A/B testing setup so that users could
look at `furo` themed docs that combined the `salt-user-guide` and `salt` docs
into a better UX, with improved navigation, and default Sphinx search. He is
being redirected to focus his time on `idem-cloud` documentation and autogenerative
code for at least the next 30 to 45 days.

- [Previous Follow-ups: `furo`, style guide linting in `salt-user-guide`, etc.](https://gitlab.com/saltstack/open/docs/docs-hub/-/blob/main/meeting-notes/2021-03-04.md#follow-up-items-from-last-meeting)
- [Previous Follow-ups: salt-user-guide and Salt docs](https://gitlab.com/saltstack/open/docs/docs-hub/-/blob/main/meeting-notes/2021-03-04.md#salt-user-guide-and-salt-docs)

### Next events

- Docs clinic: March 25th, 2021
- Docs working group event: April 1st, 2021

### Misc. notes for future

> This is a placeholder for notes not belonging anywhere else

- Test suite: skip/ignore `*.rst` and `*.md` files for the Python test suite in `salt`. Only run Sphinx docs tests.

### Misc. projects

- [idem-cloud](https://gitlab.com/saltstack/pop/idem-cloud)
  - [pop-create](https://gitlab.com/saltstack/pop/pop-create): Docs bootstrapping and project templating
- GitLab API: Should really evaluate! Jim mentioned working on GitLab, specifically API documentation that involved openapi: https://gitlab.com/jimcser/gitlab/-/tree/jimcser-openapi-access-tokens/doc/api/openapi
  - This could provide some insight into the potential of autogenerative code for baseline execution modules in [`idem-gitlab`](https://gitlab.com/saltstack/pop/idem-gitlab)
- Awesome lists, bookmark automation
  - Derek made some PRs to `awesome-*` lists that help autogenerate bookmarks for a simplified way to import an awesome list into your webbrowser.
    - https://github.com/hbokh/awesome-saltstack/pull/40
    - https://gitlab.com/saltstack/pop/pop-awesome/-/merge_requests
